/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.CIImage;

import dwt.internal.cocoa.CGFloat;
import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSBitmapImageRep;
import dwt.internal.cocoa.NSImage : NSCompositingOperation;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSPoint;
import dwt.internal.cocoa.NSRect;
import objc = dwt.internal.objc.runtime;

public class CIImage : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void drawAtPoint (NSPoint point, NSRect fromRect, NSCompositingOperation op, CGFloat delta)
    {
        OS.objc_msgSend(this.id, OS.sel_drawAtPoint_1fromRect_1operation_1fraction_1, point, fromRect, op, delta);
    }

    public void drawInRect (NSRect rect, NSRect fromRect, NSCompositingOperation op, CGFloat delta)
    {
        OS.objc_msgSend(this.id, OS.sel_drawInRect_1fromRect_1operation_1fraction_1, rect, fromRect, op, delta);
    }

    public CIImage initWithBitmapImageRep (NSBitmapImageRep bitmapImageRep)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithBitmapImageRep_1, bitmapImageRep !is null ? bitmapImageRep.id : null);
        return result !is null ? this : null;
    }

}
