/*******************************************************************************
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.DOMKeyboardEvent;

import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;

public class DOMKeyboardEvent : NSObject {

    public this () {
        super();
    }

    public this (int id) {
        super(id);
    }

    public bool altKey () {
        return OS.objc_msgSend(this.id, OS.sel_altKey) !is 0;
    }

    public int charCode () {
        return OS.objc_msgSend(this.id, OS.sel_charCode);
    }

    public bool ctrlKey () {
        return OS.objc_msgSend(this.id, OS.sel_ctrlKey) !is 0;
    }

    public bool getModifierState (NSString keyIdentifierArg) {
        return OS.objc_msgSend(this.id, OS.sel_getModifierState_1, keyIdentifierArg !is null ? keyIdentifierArg.id : 0) !is 0;
    }

    public int keyCode () {
        return OS.objc_msgSend(this.id, OS.sel_keyCode);
    }

    public int keyLocation () {
        return OS.objc_msgSend(this.id, OS.sel_keyLocation);
    }

    public bool metaKey () {
        return OS.objc_msgSend(this.id, OS.sel_metaKey) !is 0;
    }

    public void preventDefault () {
        OS.objc_msgSend(this.id, OS.sel_preventDefault);
    }

    public bool shiftKey () {
        return OS.objc_msgSend(this.id, OS.sel_shiftKey) !is 0;
    }

}
