/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSClassDescription;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSClassDescription : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray attributeKeys ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_attributeKeys);
        return result !is null ? new NSArray(result) : null;
    }

    public static NSClassDescription classDescriptionForClass (objc.Class aClass)
    {
        objc.id result = OS.objc_msgSend(OS.class_NSClassDescription, OS.sel_classDescriptionForClass_1, aClass);
        return result !is null ? new NSClassDescription(result) : null;
    }

    public static void invalidateClassDescriptionCache ()
    {
        OS.objc_msgSend(OS.class_NSClassDescription, OS.sel_invalidateClassDescriptionCache);
    }

    public NSString inverseForRelationshipKey (NSString relationshipKey)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_inverseForRelationshipKey_1, relationshipKey !is null ? relationshipKey.id : null);
        return result !is null ? new NSString(result) : null;
    }

    public static void registerClassDescription (NSClassDescription description, objc.Class aClass)
    {
        OS.objc_msgSend(OS.class_NSClassDescription, OS.sel_registerClassDescription_1forClass_1, description !is null ? description.id : null,
                aClass);
    }

    public NSArray toManyRelationshipKeys ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_toManyRelationshipKeys);
        return result !is null ? new NSArray(result) : null;
    }

    public NSArray toOneRelationshipKeys ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_toOneRelationshipKeys);
        return result !is null ? new NSArray(result) : null;
    }

}
