/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSFormatter;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSAttributedString;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSRange;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSFormatter : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSAttributedString attributedStringForObjectValue (id obj, NSDictionary attrs)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_attributedStringForObjectValue_1withDefaultAttributes_1, obj !is null ? obj.id : null,
                attrs !is null ? attrs.id : null);
        return result !is null ? new NSAttributedString(result) : null;
    }

    public NSString editingStringForObjectValue (id obj)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_editingStringForObjectValue_1, obj !is null ? obj.id : null);
        return result !is null ? new NSString(result) : null;
    }

    public bool getObjectValue (objc.id* obj, NSString str, objc.id** error)
    {
        return OS.objc_msgSend(this.id, OS.sel_getObjectValue_1forString_1errorDescription_1, obj, str !is null ? str.id : null, error) !is null;
    }

    public bool isPartialStringValid_newEditingString_errorDescription_ (NSString partialString, objc.id** newString, objc.id** error)
    {
        return OS.objc_msgSend(this.id, OS.sel_isPartialStringValid_1newEditingString_1errorDescription_1,
                partialString !is null ? partialString.id : null, newString, error) !is null;
    }

    public bool isPartialStringValid_proposedSelectedRange_originalString_originalSelectedRange_errorDescription_ (objc.id** partialStringPtr,
            NSRangePointer proposedSelRangePtr, NSString origString, NSRange origSelRange, objc.id** error)
    {
        return OS.objc_msgSend(this.id,
                OS.sel_isPartialStringValid_1proposedSelectedRange_1originalString_1originalSelectedRange_1errorDescription_1, partialStringPtr,
                proposedSelRangePtr, origString !is null ? origString.id : null, origSelRange, error) !is null;
    }

    public NSString stringForObjectValue (id obj)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_stringForObjectValue_1, obj !is null ? obj.id : null);
        return result !is null ? new NSString(result) : null;
    }

}
