/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSGarbageCollector;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSZone;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSGarbageCollector : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void collectExhaustively ()
    {
        OS.objc_msgSend(this.id, OS.sel_collectExhaustively);
    }

    public void collectIfNeeded ()
    {
        OS.objc_msgSend(this.id, OS.sel_collectIfNeeded);
    }

    public static id defaultCollector ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSGarbageCollector, OS.sel_defaultCollector);
        return result !is null ? new id(result) : null;
    }

    public void disable ()
    {
        OS.objc_msgSend(this.id, OS.sel_disable);
    }

    public void disableCollectorForPointer (void* ptr)
    {
        OS.objc_msgSend(this.id, OS.sel_disableCollectorForPointer_1, ptr);
    }

    public void enable ()
    {
        OS.objc_msgSend(this.id, OS.sel_enable);
    }

    public void enableCollectorForPointer (void* ptr)
    {
        OS.objc_msgSend(this.id, OS.sel_enableCollectorForPointer_1, ptr);
    }

    public bool isCollecting ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isCollecting) !is null;
    }

    public bool isEnabled ()
    {
        return OS.objc_msgSend(this.id, OS.sel_isEnabled) !is null;
    }

    public NSZone zone ()
    {
        return OS.objc_msgSend(this.id, OS.sel_zone);
    }

}
