/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSIndexSpecifier;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSScriptObjectSpecifier;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSIndexSpecifier : NSScriptObjectSpecifier
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSInteger index ()
    {
        return OS.objc_msgSend(this.id, OS.sel_index);
    }

    public id initWithContainerClassDescription (NSScriptClassDescription classDesc, NSScriptObjectSpecifier container, NSString property, NSInteger index)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithContainerClassDescription_1containerSpecifier_1key_1index_1,
                classDesc !is null ? classDesc.id : null, container !is null ? container.id : null, property !is null ? property.id : null, index);
        return result !is null ? new id(result) : null;
    }

    public void setIndex (NSInteger index)
    {
        OS.objc_msgSend(this.id, OS.sel_setIndex_1, index);
    }

}
