/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMetadataItem;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMetadataItem : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray attributes ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_attributes);
        return result !is null ? new NSArray(result) : null;
    }

    public id valueForAttribute (NSString key)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_valueForAttribute_1, key !is null ? key.id : null);
        return result !is null ? new id(result) : null;
    }

    public NSDictionary valuesForAttributes (NSArray keys)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_valuesForAttributes_1, keys !is null ? keys.id : null);
        return result !is null ? new NSDictionary(result) : null;
    }

}
