/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMetadataQueryResultGroup;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSInteger;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSMetadataQueryResultGroup : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSString attribute ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_attribute);
        return result !is null ? new NSString(result) : null;
    }

    public id resultAtIndex (NSUInteger idx)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_resultAtIndex_1, idx);
        return result !is null ? new id(result) : null;
    }

    public NSUInteger resultCount ()
    {
        return OS.objc_msgSend(this.id, OS.sel_resultCount);
    }

    public NSArray results ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_results);
        return result !is null ? new NSArray(result) : null;
    }

    public NSArray subgroups ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_subgroups);
        return result !is null ? new NSArray(result) : null;
    }

    public id value ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_value);
        return result !is null ? new id(result) : null;
    }

}
