/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSMutableURLRequest;

import dwt.internal.cocoa.NSData;
import dwt.internal.cocoa.NSDate : NSTimeInterval;
import dwt.internal.cocoa.NSDictionary;
import dwt.internal.cocoa.NSInputStream;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.NSURL;
import dwt.internal.cocoa.NSURLRequest;
import dwt.internal.cocoa.OS;
import dwt.internal.objc.runtime;

public class NSMutableURLRequest : NSURLRequest
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public void addValue (NSString value, NSString field)
    {
        OS.objc_msgSend(this.id, OS.sel_addValue_1forHTTPHeaderField_1, value !is null ? value.id : null, field !is null ? field.id : null);
    }

    public void setAllHTTPHeaderFields (NSDictionary headerFields)
    {
        OS.objc_msgSend(this.id, OS.sel_setAllHTTPHeaderFields_1, headerFields !is null ? headerFields.id : null);
    }

    public void setCachePolicy (NSURLRequestCachePolicy policy)
    {
        OS.objc_msgSend(this.id, OS.sel_setCachePolicy_1, policy);
    }

    public void setHTTPBody (NSData data)
    {
        OS.objc_msgSend(this.id, OS.sel_setHTTPBody_1, data !is null ? data.id : null);
    }

    public void setHTTPBodyStream (NSInputStream inputStream)
    {
        OS.objc_msgSend(this.id, OS.sel_setHTTPBodyStream_1, inputStream !is null ? inputStream.id : null);
    }

    public void setHTTPMethod (NSString method)
    {
        OS.objc_msgSend(this.id, OS.sel_setHTTPMethod_1, method !is null ? method.id : null);
    }

    public void setHTTPShouldHandleCookies (bool should)
    {
        OS.objc_msgSend(this.id, OS.sel_setHTTPShouldHandleCookies_1, should);
    }

    public void setMainDocumentURL (NSURL URL)
    {
        OS.objc_msgSend(this.id, OS.sel_setMainDocumentURL_1, URL !is null ? URL.id : null);
    }

    public void setTimeoutInterval (double seconds)
    {
        OS.objc_msgSend(this.id, OS.sel_setTimeoutInterval_1, seconds);
    }

    public void setURL (NSURL URL)
    {
        OS.objc_msgSend(this.id, OS.sel_setURL_1, URL !is null ? URL.id : null);
    }

    public void setValue (NSString value, NSString field)
    {
        OS.objc_msgSend(this.id, OS.sel_setValue_1forHTTPHeaderField_1, value !is null ? value.id : null, field !is null ? field.id : null);
    }

}
