/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSNetServiceBrowser;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSRunLoop;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSNetServiceBrowser : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id delegatee ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_delegate);
        return result !is null ? new id(result) : null;
    }

    public void removeFromRunLoop (NSRunLoop aRunLoop, NSString mode)
    {
        OS.objc_msgSend(this.id, OS.sel_removeFromRunLoop_1forMode_1, aRunLoop !is null ? aRunLoop.id : null, mode !is null ? mode.id : null);
    }

    public void scheduleInRunLoop (NSRunLoop aRunLoop, NSString mode)
    {
        OS.objc_msgSend(this.id, OS.sel_scheduleInRunLoop_1forMode_1, aRunLoop !is null ? aRunLoop.id : null, mode !is null ? mode.id : null);
    }

    public void searchForAllDomains ()
    {
        OS.objc_msgSend(this.id, OS.sel_searchForAllDomains);
    }

    public void searchForBrowsableDomains ()
    {
        OS.objc_msgSend(this.id, OS.sel_searchForBrowsableDomains);
    }

    public void searchForRegistrationDomains ()
    {
        OS.objc_msgSend(this.id, OS.sel_searchForRegistrationDomains);
    }

    public void searchForServicesOfType (NSString type, NSString domainString)
    {
        OS.objc_msgSend(this.id, OS.sel_searchForServicesOfType_1inDomain_1, type !is null ? type.id : null,
                domainString !is null ? domainString.id : null);
    }

    public void setDelegate (id delegatee)
    {
        OS.objc_msgSend(this.id, OS.sel_setDelegate_1, delegatee !is null ? delegatee.id : null);
    }

    public void stop ()
    {
        OS.objc_msgSend(this.id, OS.sel_stop);
    }

}
