/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSNibConnector;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSNibConnector : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id destination ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_destination);
        return result !is null ? new id(result) : null;
    }

    public void establishConnection ()
    {
        OS.objc_msgSend(this.id, OS.sel_establishConnection);
    }

    public NSString label ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_label);
        return result !is null ? new NSString(result) : null;
    }

    public void replaceObject (id oldObject, id newObject)
    {
        OS.objc_msgSend(this.id, OS.sel_replaceObject_1withObject_1, oldObject !is null ? oldObject.id : null,
                newObject !is null ? newObject.id : null);
    }

    public void setDestination (id destination)
    {
        OS.objc_msgSend(this.id, OS.sel_setDestination_1, destination !is null ? destination.id : null);
    }

    public void setLabel (NSString label)
    {
        OS.objc_msgSend(this.id, OS.sel_setLabel_1, label !is null ? label.id : null);
    }

    public void setSource (id source)
    {
        OS.objc_msgSend(this.id, OS.sel_setSource_1, source !is null ? source.id : null);
    }

    public id source ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_source);
        return result !is null ? new id(result) : null;
    }

}
