/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSPageLayout;

import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSPageLayout;
import dwt.internal.cocoa.NSPrintInfo;
import dwt.internal.cocoa.NSView;
import dwt.internal.cocoa.NSViewController;
import dwt.internal.cocoa.NSWindow;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSPageLayout : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public NSArray accessoryControllers ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_accessoryControllers);
        return result !is null ? new NSArray(result) : null;
    }

    public NSView accessoryView ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_accessoryView);
        return result !is null ? new NSView(result) : null;
    }

    public void addAccessoryController (NSViewController accessoryController)
    {
        OS.objc_msgSend(this.id, OS.sel_addAccessoryController_1, accessoryController !is null ? accessoryController.id : null);
    }

    public void beginSheetWithPrintInfo (NSPrintInfo printInfo, NSWindow docWindow, id delegatee, objc.SEL didEndSelector, void* contextInfo)
    {
        OS.objc_msgSend(this.id, OS.sel_beginSheetWithPrintInfo_1modalForWindow_1delegate_1didEndSelector_1contextInfo_1,
                printInfo !is null ? printInfo.id : null, docWindow !is null ? docWindow.id : null, delegatee !is null ? delegatee.id : null,
                didEndSelector, contextInfo);
    }

    public static NSPageLayout pageLayout ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSPageLayout, OS.sel_pageLayout);
        return result !is null ? new NSPageLayout(result) : null;
    }

    public NSPrintInfo printInfo ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_printInfo);
        return result !is null ? new NSPrintInfo(result) : null;
    }

    public void readPrintInfo ()
    {
        OS.objc_msgSend(this.id, OS.sel_readPrintInfo);
    }

    public void removeAccessoryController (NSViewController accessoryController)
    {
        OS.objc_msgSend(this.id, OS.sel_removeAccessoryController_1, accessoryController !is null ? accessoryController.id : null);
    }

    public NSInteger runModal ()
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_runModal);
    }

    public NSInteger runModalWithPrintInfo (NSPrintInfo printInfo)
    {
        return cast(NSInteger) OS.objc_msgSend(this.id, OS.sel_runModalWithPrintInfo_1, printInfo !is null ? printInfo.id : null);
    }

    public void setAccessoryView (NSView accessoryView)
    {
        OS.objc_msgSend(this.id, OS.sel_setAccessoryView_1, accessoryView !is null ? accessoryView.id : null);
    }

    public void writePrintInfo ()
    {
        OS.objc_msgSend(this.id, OS.sel_writePrintInfo);
    }

}
