/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSRecursiveLock;

import dwt.internal.cocoa.NSDate;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSRecursiveLock : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool lockBeforeDate (NSDate limit)
    {
        return OS.objc_msgSend(this.id, OS.sel_lockBeforeDate_1, limit !is null ? limit.id : null) !is null;
    }

    public NSString name ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_name);
        return result !is null ? new NSString(result) : null;
    }

    public void setName (NSString n)
    {
        OS.objc_msgSend(this.id, OS.sel_setName_1, n !is null ? n.id : null);
    }

    public bool tryLock ()
    {
        return OS.objc_msgSend(this.id, OS.sel_tryLock) !is null;
    }

}
