/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSScriptCoercionHandler;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSScriptCoercionHandler : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id coerceValue (id value, objc.Class toClass)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_coerceValue_1toClass_1, value !is null ? value.id : null, toClass);
        return result !is null ? new id(result) : null;
    }

    public void registerCoercer (id coercer, objc.SEL selector, objc.Class fromClass, objc.Class toClass)
    {
        OS.objc_msgSend(this.id, OS.sel_registerCoercer_1selector_1toConvertFromClass_1toClass_1, coercer !is null ? coercer.id : null, selector,
                fromClass, toClass);
    }

    public static NSScriptCoercionHandler sharedCoercionHandler ()
    {
        objc.id result = OS.objc_msgSend(OS.class_NSScriptCoercionHandler, OS.sel_sharedCoercionHandler);
        return result !is null ? new NSScriptCoercionHandler(result) : null;
    }

}
