/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSSortDescriptor;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSComparisonResult;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.NSString;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSSortDescriptor : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public bool ascending ()
    {
        return OS.objc_msgSend(this.id, OS.sel_ascending) !is null;
    }

    public NSComparisonResult compareObject (id object1, id object2)
    {
        return cast(NSComparisonResult) OS.objc_msgSend(this.id, OS.sel_compareObject_1toObject_1, object1 !is null ? object1.id : null, object2 !is null ? object2.id : null);
    }

    public id initWithKey_ascending_ (NSString key, bool ascending)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithKey_1ascending_1, key !is null ? key.id : null, ascending);
        return result !is null ? new id(result) : null;
    }

    public id initWithKey_ascending_selector_ (NSString key, bool ascending, objc.SEL selector)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithKey_1ascending_1selector_1, key !is null ? key.id : null, ascending, selector);
        return result !is null ? new id(result) : null;
    }

    public NSString key ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_key);
        return result !is null ? new NSString(result) : null;
    }

    public id reversedSortDescriptor ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_reversedSortDescriptor);
        return result !is null ? new id(result) : null;
    }

    public objc.SEL selector ()
    {
        return OS.objc_msgSend(this.id, OS.sel_selector);
    }

}
