/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSTextAttachment;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSFileWrapper;
import dwt.internal.cocoa.NSObject;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSTextAttachment : NSObject
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id attachmentCell ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_attachmentCell);
        return result !is null ? new id(result) : null;
    }

    public NSFileWrapper fileWrapper ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_fileWrapper);
        return result !is null ? new NSFileWrapper(result) : null;
    }

    public id initWithFileWrapper (NSFileWrapper fileWrapper)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithFileWrapper_1, fileWrapper !is null ? fileWrapper.id : null);
        return result !is null ? new id(result) : null;
    }

    public void setAttachmentCell (id cell)
    {
        OS.objc_msgSend(this.id, OS.sel_setAttachmentCell_1, cell !is null ? cell.id : null);
    }

    public void setFileWrapper (NSFileWrapper fileWrapper)
    {
        OS.objc_msgSend(this.id, OS.sel_setFileWrapper_1, fileWrapper !is null ? fileWrapper.id : null);
    }

}
