/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     
 * Port to the D Programming language:
 *     Jacob Carlborg <jacob.carlborg@gmail.com>
 *******************************************************************************/
module dwt.internal.cocoa.NSViewAnimation;

import dwt.internal.cocoa.id;
import dwt.internal.cocoa.NSAnimation;
import dwt.internal.cocoa.NSArray;
import dwt.internal.cocoa.OS;
import objc = dwt.internal.objc.runtime;

public class NSViewAnimation : NSAnimation
{

    public this ()
    {
        super();
    }

    public this (objc.id id)
    {
        super(id);
    }

    public id initWithViewAnimations (NSArray viewAnimations)
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_initWithViewAnimations_1, viewAnimations !is null ? viewAnimations.id : null);
        return result !is null ? new id(result) : null;
    }

    public void setViewAnimations (NSArray viewAnimations)
    {
        OS.objc_msgSend(this.id, OS.sel_setViewAnimations_1, viewAnimations !is null ? viewAnimations.id : null);
    }

    public NSArray viewAnimations ()
    {
        objc.id result = OS.objc_msgSend(this.id, OS.sel_viewAnimations);
        return result !is null ? new NSArray(result) : null;
    }

}
